/*
 * This file is a part of the SteamWar software.
 *
 * Copyright (C) 2021  SteamWar.de-Serverteam
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package de.steamwar.lobby.command;

import de.steamwar.command.SWCommand;
import de.steamwar.lobby.LobbySystem;
import de.steamwar.lobby.display.Hologram;
import org.bukkit.entity.Player;

public class HologramCommand extends SWCommand {

    public HologramCommand() {
        super("hologram");
    }

    @Register(help = true)
    public void genericHelp(Player player, String... args) {
        if (PortalCommand.noPermissions(player)) return;

        player.sendMessage("/hologram create <id> <text>");
        player.sendMessage("/hologram list");
        player.sendMessage("/hologram delete <id>");
    }

    @Register("create")
    public void portalCreate(Player player, String id, String... text) {
        if (PortalCommand.noPermissions(player)) return;

        new Hologram(id, player.getLocation(), String.join(" ", text).replace("&", "§"), false);
        LobbySystem.config().save();
    }

    @Register("list")
    public void portalList(Player player) {
        if (PortalCommand.noPermissions(player)) return;
        Hologram.getHolograms().forEach(hologram -> player.sendMessage(hologram.toString()));
    }

    @Register("delete")
    public void portalDelete(Player player, String id) {
        if (PortalCommand.noPermissions(player)) return;

        Hologram hologram = Hologram.getHologram(id);
        if (hologram == null)
            return;

        hologram.delete();
        LobbySystem.config().save();
    }
}
